<?php

add_action('plugins_loaded', 'WC_paystar', 0); 

function WC_paystar() 
{
    if(!class_exists('WC_Payment_Gateway')) 
		return;
	
	if (class_exists('WC_Payment_Gateway') && !class_exists('WC_full_paystar') && !function_exists('Woocommerce_Add_Paystar_Gateway')) {

			add_filter('woocommerce_payment_gateways', 'woocommerce_add_paystar_gateway');

		    function woocommerce_add_paystar_gateway($methods) 
			{
		        $methods[] = 'WC_full_paystar';
		        return $methods;
		    }
	        
	    class WC_full_paystar extends WC_Payment_Gateway
		{
	        public function __construct()
			{
	        	require_once(dirname(__FILE__) . '/lib/paystarconfig.php');
				$this->paystarconfig 		 = $ws_config;
				
	            $this->id 			 	 = 'paystar';
	            $this->method_title 	 = $this->paystarconfig['name'];
	            $this->icon = apply_filters('WC_Paystar_logo', WP_PLUGIN_URL . "/" . plugin_basename(dirname(__FILE__)) . '/assets/images/logo.png');
	            $this->has_fields 	   	 = false;
	            $this->init_form_fields();
	            $this->init_settings();
				
				$this->title				= $this->settings['title'];
				$this->description			= $this->settings['description'];
				$this->paystar_pin			 	= $this->settings['paystar_pin'];
				$this->paystar_bank			= $this->settings['paystar_bank'];
				$this->redirect_page_id	= $this->settings['redirect_page_id'];
	 
				$this->msg['message'] = "";
				$this->msg['class'] = "";
	 
				add_action('woocommerce_api_' . strtolower(get_class($this)), array($this, 'check_paystar_response'));
				add_action('valid-paystar-request', array($this, 'successful_request'));

	  		    if(version_compare(WOOCOMMERCE_VERSION, '2.0.0', '>=')) 
	                add_action('woocommerce_update_options_payment_gateways_paystar', array(&$this, 'process_admin_options'));
	             else 
	                add_action('woocommerce_update_options_payment_gateways', array(&$this, 'process_admin_options'));
				 
				add_action('woocommerce_receipt_paystar', array(&$this, 'receipt_page'));
	        }

			private function paystarapi($amount=0, $tc='', $desc='test woocommerce', $verify=false)
			{	
				$res = false;
				try 
				{
					if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
						$ip = $_SERVER['HTTP_CLIENT_IP'];
					} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
						$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
					} else {
						$ip = $_SERVER['REMOTE_ADDR'];
					}
					$m = !empty($verify) ? 'verify' : 'create';
					
					$f = array(
						'amount' => round($amount),
						'pin' => $this->paystar_pin,
						'ip' => $ip,
						!empty($verify) ? 'transid' : 'callback' => $tc 
					);	
					
					if(empty($verify))
						$f = array_merge($f, array('bank'=>$this->paystar_bank,'description'=>$desc)); 				

					$f_ = '';
					foreach($f as $k=>$v) 
						$f_ .= $k . '=' . urlencode($v) . '&'; 
						
					rtrim($f_, '&');

					$ch = curl_init();
					curl_setopt($ch,CURLOPT_URL, "http://{$this->paystarconfig['address']}/api/{$m}/");
					curl_setopt($ch,CURLOPT_POST, count($f));
					curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
					curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
					$res = curl_exec($ch);
					curl_close($ch);				
				}
				catch(Exception $e) 
				{
					return -900;
				} 

				return !empty($res) ? $res : false;
			}
		
	       function init_form_fields()
		   {
	            $this->form_fields = array(
	                'enabled' => array(
	                    'title' => 'فعال سازی/غیر فعال سازی :',
	                    'type' => 'checkbox',
	                    'label' => 'فعال سازی درگاه پرداخت ' . $this->paystarconfig['name'],
	                    'description' => 'برای امکان پرداخت کاربران از طریق این درگاه باید تیک فعال سازی زده شده باشد .',
	                    'default' => 'no'
					),
	                'paystar_pin' => array(
	                    'title' => 'شناسه درگاه :',
	                    'type' => 'text',
	                    'description' => 'شناسه درگاه خود را وارد نمایید .'
					),
	                'paystar_bank' => array(
	                    'title' => 'بانک :',
	                    'type' => 'select',
	                    'options' => $this->paystarconfig['bank'],
	                    'description' => 'بانک مورد نظر برای انجام تراکنش ها را انتخاب نمایید .'
					),
	                'title' => array(
	                    'title' => 'عنوان درگاه :',
	                    'type'=> 'text',
	                    'description' => 'این عتوان در سایت برای کاربر نمایش داده می شود .',
	                    'default' => 'درگاه پرداخت ' . $this->paystarconfig['name']
					),
	                'description' => array(
	                    'title' => 'توضیحات درگاه :',
	                    'type' => 'textarea',
	                    'description' => 'این توضیحات در سایت، بعد از انتخاب درگاه توسط کاربر نمایش داده می شود .',
	                    'default' => 'پرداخت وجه از طریق درگاه ' . $this->paystarconfig['name'] . ' توسط تمام کارت های عضو شتاب .'
					),
					'redirect_page_id' => array(
	                    'title' => 'آدرس بازگشت',
	                    'type' => 'select',
	                    'options' => $this->get_pages('صفحه مورد نظر را انتخاب نمایید'),
	                    'description' => "صفحه‌ای که در صورت پرداخت موفق نشان داده می‌شود را نشان دهید."
					)
	         );
	        }
			
	        public function admin_options()
			{
	            echo '<h3>'.__('درگاه پرداخت ' . $this->paystarconfig['name'], 'paystar').'</h3>';
	            echo '<p>'.__('درگاه پرداخت اینترنتی ' . $this->paystarconfig['name']).'</p>';
	            echo '<table class="form-table">';
	            $this->generate_settings_html();
	            echo '</table>';
			}

			function receipt_page($order_id)
			{
	            global $woocommerce;
	            $order = new WC_Order($order_id);
	            $currency = $order->get_order_currency();
                $currency = apply_filters('WC_paystar_Currency', $currency, $order_id);
	            $callback = ($this->redirect_page_id=="" || $this->redirect_page_id==0) ? get_site_url() . "/" : get_permalink($this->redirect_page_id);
				$callback = add_query_arg('wc-api', get_class($this), $callback);
				unset($woocommerce->session->zegersot);
				unset($woocommerce->session->zegersot_id);
				$woocommerce->session->zegersot = $order_id;			

				$items_list = NULL;
				foreach ($order->get_items() as $item)
				{
					if(isset($items_list))
						$items_list .= "-" . $item['name'];
					else
						$items_list = $item['name'];
				}
				
				$callback = $callback . '&order_id=' . $order_id; 

				$Amount = intval($order->order_total);
                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_before_check_currency', $Amount, $currency);
                if (strtolower($currency) == strtolower('IRT') || strtolower($currency) == strtolower('TOMAN') || strtolower($currency) == strtolower('Iran TOMAN') || strtolower($currency) == strtolower('Iranian TOMAN') || strtolower($currency) == strtolower('Iran-TOMAN') || strtolower($currency) == strtolower('Iranian-TOMAN') || strtolower($currency) == strtolower('Iran_TOMAN') || strtolower($currency) == strtolower('Iranian_TOMAN') || strtolower($currency) == strtolower('تومان') || strtolower($currency) == strtolower('تومان ایران')
                )
                    $Amount = $Amount * 1;
                else if (strtolower($currency) == strtolower('IRHT'))
                    $Amount = $Amount * 1000;
                else if (strtolower($currency) == strtolower('IRHR'))
                    $Amount = $Amount * 100;
                else if (strtolower($currency) == strtolower('IRR'))
                    $Amount = $Amount / 10;


                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_after_check_currency', $Amount, $currency);
                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_irt', $Amount, $currency);
                $Amount = apply_filters('woocommerce_order_amount_total_paystar_gateway', $Amount, $currency);

				$res = $this->paystarapi($Amount, $callback, 'شناسه سفارش : ' . $order_id);
				if(empty($res) or $res == -900) 
					echo 'اتصال به بانک برقرار نشد .';
				else if(strlen($res) > 5)
				{
					$woocommerce->session->zegersot_id = $res;
					header("Location: http://{$this->paystarconfig['address']}/paying/{$res}");
					exit;
				}	
				else
					echo "خطا ({$res})";							
	        }
	        
	        function process_payment($order_id)
			{
	                $order = new WC_Order($order_id);
	                return array(
	                    'result' => 'success',
	                    'redirect' => $order->get_checkout_payment_url(true)
	                );
	        }
		
		    function check_paystar_response()
			{
				global $woocommerce;
				$order_id = $_GET['order_id'];
				$order = new WC_Order($order_id);
				$currency = $order->get_order_currency();
                $currency = apply_filters('WC_paystar_Currency', $currency, $order_id);
                
				$transid = @$_POST["transid"];
				if(!empty($transid))
				{
					$Amount = intval($order->order_total);
                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_before_check_currency', $Amount, $currency);
                if (strtolower($currency) == strtolower('IRT') || strtolower($currency) == strtolower('TOMAN') || strtolower($currency) == strtolower('Iran TOMAN') || strtolower($currency) == strtolower('Iranian TOMAN') || strtolower($currency) == strtolower('Iran-TOMAN') || strtolower($currency) == strtolower('Iranian-TOMAN') || strtolower($currency) == strtolower('Iran_TOMAN') || strtolower($currency) == strtolower('Iranian_TOMAN') || strtolower($currency) == strtolower('تومان') || strtolower($currency) == strtolower('تومان ایران')
                )
                    $Amount = $Amount * 1;
                else if (strtolower($currency) == strtolower('IRHT'))
                    $Amount = $Amount * 1000;
                else if (strtolower($currency) == strtolower('IRHR'))
                    $Amount = $Amount * 100;
                else if (strtolower($currency) == strtolower('IRR'))
                    $Amount = $Amount / 10;


                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_after_check_currency', $Amount, $currency);
                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_irt', $Amount, $currency);
                $Amount = apply_filters('woocommerce_order_amount_total_paystar_gateway', $Amount, $currency);	
					$res = $this->paystarapi($Amount, $transid, '', true);
					if(empty($res))	
					{
						$this->msg['class'] = 'woocommerce_error';
						$this->msg['message'] = "پرداخت ناموفق";	
						$order->add_order_note('تراکنش پرداخت نشده است .');
						$order->add_order_note($this->msg['message']);					
					}
					else if($res == 1)
					{
						$this->msg['message'] = "پرداخت شما با موفقیت انجام شد";
						$this->msg['class'] = 'woocommerce_message';
						$order->payment_complete();
						$order->add_order_note($this->msg['message']);
						$order->add_order_note('پرداخت انجام شد .<br/>کد پیگیری : ' . $transid);					
						$woocommerce->cart->empty_cart();					
					}
					else
					{
						$res = ($res == -900) ? 'ارتباط با بانک برقرار نشده است' : $res;
						$this->msg['class'] = 'woocommerce_error';
						$this->msg['message'] = 'خطا : ' . $res;	
						$order->add_order_note('پرداخت ناموفق');
						$order->add_order_note($this->msg['message']);
					}	
				}
				else
				{
					$this->msg['class'] = 'woocommerce_error';
					$this->msg['message'] = "پرداخت ناموفق";	
					$order->add_order_note('اطلاعات ارسالی صحیح نمیباشد .');
					$order->add_order_note($this->msg['message']);
				}
				
				$redirect_url = ($this->redirect_page_id=="" || $this->redirect_page_id==0)?get_site_url() . "/":get_permalink($this->redirect_page_id);
				$redirect_url = add_query_arg(array('msg'=> base64_encode($this->msg['message']), 'type'=>$this->msg['class']), $redirect_url);
				wp_redirect($redirect_url);
	            exit;
			}

		    function get_pages($title = false, $indent = true) 
			{
		        $wp_pages = get_pages('sort_column=menu_order');
		        $page_list = array();
		        if ($title) $page_list[] = $title;
		        foreach ($wp_pages as $page) 
				{
		            $prefix = '';
		            if ($indent) 
					{
		                $has_parent = $page->post_parent;
		                while($has_parent) 
						{
		                    $prefix .=  ' - ';
		                    $next_page = get_page($has_parent);
		                    $has_parent = $next_page->post_parent;
		                }
		            }
		            $page_list[$page->ID] = $prefix . $page->post_title;
		        }
		        return $page_list;
		    }
		}
	}
}

if($_GET['msg']!='')
{
	add_action('the_content', 'showMessage');
	
	function showMessage($content)
	{
			return '<div class="' . htmlentities($_GET['type']) . '">' . base64_decode($_GET['msg']) . '</div>' . $content;
	}
}
?>